module entropical
import StdEnv, utils, ppm, ArgEnv

text_transform trans text :== {c \\ c <- trans src_list} where
  src_list = [c \\ c <-: text]

is_cap c = c>='A' && c<='Z'
decap c = toChar (toInt c + 32)
cap c = toChar (toInt c - 32)

transform_caps :: {#Char} -> {#Char}
transform_caps text = text_transform f text where
  f :: [Char] -> [Char]
  f [] = []
  f [c : d : rest] | is_cap c && not (is_cap d) = [z : decap c : d : f rest]
  f [c : rest] = [c : f rest]
  z = toChar 0

inverse_transform_caps :: {#Char} -> {#Char}
inverse_transform_caps text = text_transform f text where
  f :: [Char] -> [Char]
  f [] = []
  f [z : c : rest] | z == zr = [cap c : f rest]
  f [c : rest] = [c : f rest]
  zr = toChar 0
  
fileSize :: *File -> *(!Int, *File)  
fileSize f
  # (ok, f) = fseek f 0 FSeekEnd
  # (pos, f) = fposition f 
  # (ok, f) = fseek f 0 FSeekSet
  = (pos, f)
  
is_text :: .{#Char} -> Bool
is_text str = no_zero && nletters > (size str)/2  where
  cnts0 :: *{#Int}
  cnts0 = createArray 256 0
  cnts = foldArray count cnts0 str
  no_zero = cnts.[0]==0
  nletters = sum [cnts.[i] \\ i<-[65..122]]  
  count cnts c
    #! i = toInt c
    #! old = cnts.[i]
    = {cnts & [i] = old+1 }
  
Start world
  #!cmdline = getCommandLine 
  | size cmdline < 4 = abort "entropical {c|d} infile outfile"
  # (ok, f, world) = fopen cmdline.[2] FReadData world
  | ok==False = abort "cannot open in file"
  # (ok, fo, world) = fopen cmdline.[3] FWriteData world
  | ok==False = abort "cannot open out file"
  | cmdline.[1] == "c"   
     # (fsize, f) = fileSize f
     # (text, f) = freads f fsize
     # (_, world) = fclose f world
     # is_a_text = is_text text
     # text = if is_a_text (transform_caps text) text
     # cdata = ppm_compress text
     #! first_byte = toInt cdata.[0]
     # cdata = if is_a_text {cdata & [0] = toChar (first_byte bitor 16)} cdata
     # fo = fwritei (size text) fo
     # fo = fwrites cdata fo
     # (ok, world) = fclose fo world
     = world
  | cmdline.[1] == "d"     
     # (sz, f) = fileSize f
     # (ok,len,f) = freadi f
     # (cdata, f) = freads f sz
     # (_, world) = fclose f world
     #! first_byte = toInt cdata.[0]
     # is_a_text = first_byte bitand 16 > 0
     # cdata & [0] = toChar (first_byte bitand 239)     
     # decompressed = ppm_decompress cdata len
     # decompressed = if is_a_text (inverse_transform_caps decompressed) decompressed
     # fo = fwrites decompressed fo
     # (ok, world) = fclose fo world
     = world

