implementation module see
import StdEnv, utils

:: EscTab :== .{#Int}
:: EscCtx :== Int //prev symb success: 1-symb, 0-esc // if (length est_list == 1) 1 0
    
rot :: !Int !Int -> Int
rot x 0 = x
rot x shift | shift > 0 = x << shift
                        = x >> ~shift

PQ :== 50
EcxM :== (PQ+1) 
KindM :== EcxM*2
YoungTh :== 256
NE :== 6
SeeDelta :== 2
EtabTh :== 1024*SeeDelta 

mk_etab :: *EscTab
mk_etab = fill etab0 0 where
  sz = (PQ+1)*2*2*2*2 //p, ecx, young, det
  etab0 = createArray sz 0
  fill tab i 
    | i > PQ = tab
    # ne = max i 1
    # nc = max (PQ-i) 1
    # tab = {tab & [(i + d)*2] = ne, [(i+d)*2+1] = nc \\ d <-[0, EcxM .. EcxM*7]}
    = fill tab (i+1)
      
see_index ne nc ecx :== (ne*PQ/(ne+nc) + ecx*EcxM + kind*KindM)*2
where 
  young = if (ne+nc < YoungTh) 0 1
  det = if (ne==NE) 0 1
  kind = det*2 + young
    
updEscN :: !Int !Int !EscCtx !*EscTab !Bool -> *EscTab
updEscN ne nc ecx etab esc
  #! i = see_index ne nc ecx
  #! se = etab.[i]
  #! sc = etab.[i+1]
  #! etab = if (se + sc > EtabTh) {etab & [i] = se/2 + 1, [i+1] = sc/2+1} etab
  #! j = if esc i (i + 1)
  #! x = etab.[j]
  = {etab & [j] = x + SeeDelta}  

// -> (ne, nc, shift, etab)
getEscN :: !Int !Int !EscCtx u:EscTab  -> v:(!Int,!Int,!Int, w:EscTab), [v u <= w]
getEscN ne nc ecx etab 
  # (changed, ne2, nc2, shift, etab) = rescale ecx etab (ne+nc) ne 
  | not changed = (ne, nc, 0, etab)
  = (ne2, nc2, shift, etab)

reestimateEsc :: EscCtx *EscTab (!Int,!Int,!Int,!Int,!Bool) -> *((!Int,!Int,!Int), *EscTab)
reestimateEsc ecx etab (cumFreq, freq, totFreq, ne, found) 
  # (changed, ne2, nc2, shift, etab) = rescale ecx etab totFreq ne 
  | not changed = ((cumFreq, freq, totFreq), etab)
  #! freq = if (cumFreq==0) ne2 (rot freq shift)
  #! cumFreq = if (cumFreq==0) 0 (rot (cumFreq - ne) shift + ne2)
  #! totFreq = ne2 + nc2  
  = ((cumFreq, freq, totFreq), etab)  

rescale :: EscCtx u:EscTab !Int !Int -> *(Bool, Int, Int, Int, v:EscTab), [u <= v]
rescale ecx etab totFreq ne  // -> change,ne, nc, shift, etab
  #! nc = totFreq-ne 
  | nc==0 || ne==0 = (False, ne, nc, 0, etab) 
  #! i = see_index ne nc ecx
  #! se = etab.[i]
  #! sc = etab.[i+1]
  #! (ne2,nc2,shift) = esc_search ne nc se sc 0 
  = (True, max 1 ne2, max 1 nc2, shift, etab) where
    esc_search ne nc se sc shift 
      # nc1 = rot nc shift  
      # ne1 = se * nc1 / sc    
      # tf = ne1 + nc1
      | tf < 1024 && nc < 32700 = esc_search ne nc se sc (shift+1) 
      | tf > 65000 = esc_search ne nc se sc (shift-1) 
      = (ne1, nc1, shift)
